; ***********************************************************
;
; Includefile fr Kernal.src, enthlt alle Routinen fr Bildschirm-
; behandlung und Tastatur
;


; -------------------------------------------------------------------------
; Sprungtabelle fr Kernal-Funktionen

        jmp     MonitorW                ; Monitor-Einsprung
        nop
jmp_scrinit:
        jmp     do_scrinit              ; Reset Tastatur unc CRT Format
jmp_GetKey:
        jmp     GetKey                  ; Zeichen aus Tastaturpuffer holen
jmp_basin_crt:
        jmp     basin_crt               ; Zeichen vom Bildschirm holen
jmp_bsout_crt:
        jmp     bsout_crt               ; Ausgabe auf CRT
jmp_screen:
        jmp     do_screen               ; Anzahl Zeilen und Spalten holen
jmp_scnkey:
        jmp     do_scnkey               ; Tastatur abfragen
        jmp     SetCurs                 ; Cursor setzen (Hardware)
jmp_plot:
        jmp     do_plot                 ; Cursorposition setzen/holen (Software)
jmp_iobase:
        jmp     do_iobase               ; Basisadresse CIA holen
jmp_escseq:
        jmp     ESCseq                  ; ESC-Sequenz ausfhren, Zeichen in AC
jmp_funkey:
        jmp     do_funkey               ; Funktionstasten listen/belegen

; -------------------------------------------------------------------------
; Cursorposition setzen/holen

do_plot:
        bcs     LE035
        stx     CursLine
        stx     LastCol
        sty     CursCol
        sty     LastLine
        jsr     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
        jsr     SetCurs                 ; Cursor setzen (Hardware)
LE035:
        ldx     CursLine
        ldy     CursCol
        rts
; -------------------------------------------------------------------------
; Begin des I/O-Bereiches holen

do_iobase:
        ldx     #<cia
        ldy     #>cia
        rts
; -------------------------------------------------------------------------
; Bildschirmformat holen

do_screen:
        ldx     #80             ; Anzahl Spalten
        ldy     #25             ; und Zeilen
        rts
; -------------------------------------------------------------------------
; Bildschirm und Tastatur rcksetzen

do_scrinit:
        lda     #$00
        ldx     #$23
LE048:
        sta     PgmKeyPtr,x     ; Zeropage-Merker lschen
        dex
        bpl     LE048
        ldx     #$20
LE04F:
        sta     rvsFlag,x
        dex
        bpl     LE04F
        lda     #$0C
        sta     RepeatDelay     ; 12*20ms = 240ms bis Tastenrepeat
        lda     #$60
        sta     Config          ; Cursorformat setzen
        lda     #<ProcessFunKey
        sta     funvec
        lda     #>ProcessFunKey
        sta     funvec+1        ; Funktionstastenvektor belegen

; Funktionstasten belegen, wenn noch nicht geschehen

        lda     PgmKeyBuf
        ora     PgmKeyBuf+1     ; bereits belegt ?
        bne     LE0AA           ; ja: skip

        lda     SysMemTop
        sta     PgmKeyEnd
        lda     SysMemTop+1
        sta     PgmKeyEnd+1
        lda     #$40
        ldx     #$00
        ldy     #$02            ; 512 Bytes...
        jsr     getmem          ; ... Speicher reservieren
        bcs     LE0AA           ; Fehler: Ende
        sta     PgmKeySeg
        inx
        stx     PgmKeyBuf
        bne     LE08D
        iny

; Texte der Funktionstasten kopieren

LE08D:
        sty     PgmKeyBuf+1
        ldy     #PgmKeyTxtLen   ; Gesamtlnge der Texte
        jsr     SwToPgmKeySeg   ; Auf Bank mit Funktionstastentexten schalten
LE094:
        lda     PgmKeyDefTxt-1,y
        dey
        sta     (PgmKeyBuf),y
        bne     LE094
        jsr     SwitchOldSeg
        ldy     #DefPgmKeyAnz           ; Anzahl zu belegender Tasten
LE0A1:
        lda     PgmKeyDefLen-1,y        ; Lngen der Texte kopieren
        sta     PgmKeySeg,y
        dey
        bne     LE0A1
LE0AA:
        jsr     ResetCRTSize            ; Bildschirmgre rcksetzen
        jsr     LE251                   ; Auf Lower Case schalten
        jsr     Init6545                ; Videocontroller initialisieren
ClrHome:
        jsr     Home                    ; Cursor nach links oben setzen
LE0B6:
        jsr     LE0CF                   ; Zeiger auf Zeile im Videoram setzen
        jsr     EraseLine               ; Zeile lschen
        cpx     ScreenBot               ; unterste Zeile erreicht ?
        inx
        bcc     LE0B6                   ; nein: nchste

; Cursor nach links oben setzen

Home:
        ldx     ScreenTop
        stx     CursLine
        stx     LastCol
LE0C7:
        ldy     ScreenLeft
        sty     CursCol
        sty     LastLine

; Zeiger auf Zeilenanfang im Videoram setzen

InitLine:
        ldx     CursLine
LE0CF:
        lda     LineLSBTab,x            ; Adresse aus Tabelle holen
        sta     CharPtr
        lda     LineMSBTab,x
        sta     CharPtr+1
        rts
; -------------------------------------------------------------------------
; Dem 6545 die Cursorposition mitteilen

SetCurs:
        ldy     #$0F
        clc
        lda     CharPtr
        adc     CursCol
        sty     crtc+CAdrReg
        sta     crtc+CDataReg
        dey
        sty     crtc+CAdrReg
        lda     crtc+CDataReg
        and     #$F8
        sta     sedt1
        lda     CharPtr+1
        adc     #$00
        and     #$07
        ora     sedt1
        sta     crtc+CDataReg
        rts
; -------------------------------------------------------------------------
; Zeichen von Tastatur holen

GetKey:
        ldx     KeyIndex        ; Zeichen von Funktionstaste ?
        beq     LE114           ; nein: jmp

; Zeichen nicht aus Puffer sondern direkt von Text holen

        ldy     PgmKeyIndex
        jsr     SwToPgmKeySeg   ; Auf Bank mit Funktionstastentexten schalten
        lda     (PgmKeyPtr),y   ; Zeichen holen
        jsr     SwitchOldSeg    ; Bank rckschalten
        dec     KeyIndex
        inc     PgmKeyIndex
        cli
        rts
; -------------------------------------------------------------------------
; Zeichen aus Tastaturpuffer holen

LE114:
        ldy     Keyd            ; erstes Zeichen im Puffer holen
        ldx     #$00
LE119:
        lda     Keyd+1,x        ; Zeichen im Puffer aufrcken
        sta     Keyd,x
        inx
        cpx     KeyBufIndex
        bne     LE119
        dec     KeyBufIndex
        tya
        cli
        rts
; -------------------------------------------------------------------------
; Warteschleife fr Tastatureingaben

LE129:
        jsr     bsout_crt       ; Ausgabe auf CRT
LE12C:
        ldy     #$0A
        lda     Config          ; Cursorformat
        sty     crtc+CAdrReg
        sta     crtc+CDataReg   ; Cursor setzen
LE136:
        lda     KeyBufIndex
        ora     KeyIndex        ; Taste gedrckt ?
        beq     LE136           ; nein: warten
        sei
        lda     #$20
        sty     crtc+CAdrReg
        sta     crtc+CDataReg   ; Cursor lschen
        jsr     GetKey          ; Zeichen holen
        cmp     #$0D            ; cr ?
        bne     LE129           ; nein, dann ausgeben und weiter warten
        sta     crsw            ; cr merken
        jsr     CurToEOL        ; Zeilenende nach xr
        stx     linetmp         ; und merken
        jsr     LE536           ; Cursor auf Zeilenanfang
        lda     #$00
        sta     QuoteSw         ; Insertflag lschen
        ldy     ScreenLeft
        lda     LastCol
        bmi     LE174
        cmp     CursLine
        bcc     LE174
        ldy     LastLine
        cmp     linetmp
        bne     LE170
        cpy     LastLinePos
        beq     LE172
LE170:
        bcs     LE183
LE172:
        sta     CursLine
LE174:
        sty     CursCol
        jmp     LE18B           ; Zeichen vom CRT holen
; -------------------------------------------------------------------------
; Eingabe vom CRT holen

basin_crt:
        tya
        pha
        txa
        pha
        lda     crsw            ; Zeile mit cr abgeschlossen ?
        beq     LE12C           ; nein: Warten
        bpl     LE18B
LE183:                          ; Zeile war zu Ende
        lda     #$00
        sta     crsw            ; Flag lschen
        lda     #$0D            ; cr rckgeben
        bne     LE1C4
LE18B:
        jsr     InitLine        ; Zeiger auf Zeilenanfang im RAM setzen
        jsr     GetChar         ; Zeichen vom Bildschirm holen
        sta     PrtData
        and     #$3F
        asl     PrtData
        bit     PrtData
        bpl     LE19D
        ora     #$80
LE19D:
        bcc     LE1A3
        ldx     QuoteSw
        bne     LE1A7
LE1A3:
        bvs     LE1A7
        ora     #$40
LE1A7:
        jsr     ChkHochKomma
        ldy     CursLine
        cpy     linetmp
        bcc     LE1BB
        ldy     CursCol
        cpy     LastLinePos
        bcc     LE1BB
        ror     crsw
        bmi     LE1BE
LE1BB:
        jsr     LE574
LE1BE:
        cmp     #$DE
        bne     LE1C4
        lda     #$FF
LE1C4:
        sta     PrtData
        pla
        tax
        pla
        tay
        lda     PrtData
        rts
; -------------------------------------------------------------------------
ChkHochKomma:
        cmp     #'"'
        bne     LE1DD
        lda     Insrt
        bne     LE1DB
        lda     QuoteSw         ; Hochkommaflag invertieren
        eor     #$01
        sta     QuoteSw
LE1DB:
        lda     #'"'
LE1DD:
        rts
; -------------------------------------------------------------------------
; Zeichen auf Bildschirm ausgeben

PrtChar:
        bit     rvsFlag
        bpl     LE1E5
        ora     #$80
LE1E5:
        ldx     Insrt
        beq     LE1EB
        dec     Insrt
LE1EB:
        bit     InsertFlag
        bpl     LE1F9
        pha
        jsr     do_INST
        ldx     #$00
        stx     Insrt
        pla
LE1F9:
        jsr     PutChar
        cpy     #$45
        bne     LE203
        jsr     bell
LE203:
        jsr     LE62E
LE206:
        lda     PrtData
        sta     LastPrtChar
        jsr     SetCurs                 ; Cursor setzen (Hardware)
        pla
        tay
        lda     Insrt
        beq     LE216
        lsr     QuoteSw
LE216:
        pla
        tax
        pla
        rts
; -------------------------------------------------------------------------
EraseChar:
        lda     #' '
PutChar:
        ldy     CursCol
        jsr     SwitchSeg
        sta     (CharPtr),y
        jsr     SwitchOldSeg    ; Bank rckschalten
        rts
; -------------------------------------------------------------------------
; aktuelle Zeile lschen

EraseLine:
        ldy     ScreenLeft
        jsr     LE505
LE22C:
        txa
        pha
        lda     CursCol
        pha
        dey
LE232:
        iny
        sty     CursCol
        jsr     EraseChar
        cpy     ScreenRight
        bne     LE232
        pla
        sta     CursCol
        pla
        tax
        rts
; -------------------------------------------------------------------------
; Zeichen vom Bildschirm holen

GetChar:
        ldy     CursCol
LE244:
        jsr     SwitchSeg
        lda     (CharPtr),y
        jsr     SwitchOldSeg    ; Bank rckschalten
        rts
; -------------------------------------------------------------------------
SwitchCase:
        ldy     #$10
        bcs     LE253
LE251:
        ldy     #$00
LE253:
        sty     GrafMode
        lda     tpi1+tpiCtrlReg
        and     #$EF
        ora     GrafMode
        sta     tpi1+tpiCtrlReg
        rts
; -------------------------------------------------------------------------
Init6545:
        ldy     #$11
        bit     tpi2+tpiPortC
        bmi     LE26D
        ldy     #$23
        bvs     LE26D
        ldy     #$35
LE26D:
        ldx     #$11
LE26F:
        lda     m6545tab,y
        stx     crtc+CAdrReg
        sta     crtc+CDataReg
        dey
        dex
        bpl     LE26F
        rts
; -------------------------------------------------------------------------
SwitchSeg:
        pha
        lda     #$3F
        bne     LE286

; Auf Bank mit Funktionstastentexten schalten

SwToPgmKeySeg:
        pha
        lda     PgmKeySeg
LE286:
        pha
        lda     IndReg
        sta     SegSave
        pla
        sta     IndReg
        pla
        rts
; -------------------------------------------------------------------------
; Bank rckschalten

SwitchOldSeg:
        pha
        lda     SegSave
        sta     IndReg
        pla
        rts
; -------------------------------------------------------------------------
; Ausgabe auf CRT

bsout_crt:
        pha
        cmp     #$FF
        bne     LE2A0
        lda     #$DE
LE2A0:
        sta     PrtData
        txa
        pha
        tya
        pha
        lda     #$00
        sta     crsw
        ldy     CursCol
        lda     PrtData
        and     #$7F
        cmp     #$20
        bcc     CtrlCode
        ldx     LastPrtChar
        cpx     #$1B
        bne     LE2C1
        jsr     do_ESC
        jmp     LE303
; -------------------------------------------------------------------------
LE2C1:
        and     #$3F
LE2C3:
        bit     PrtData
        bpl     LE2C9
        ora     #$40
LE2C9:
        jsr     ChkHochKomma
        jmp     PrtChar
; -------------------------------------------------------------------------
CtrlCode:
        cmp     #$0D
        beq     LE2FC
        cmp     #$14
        beq     LE2FC
        cmp     #$1B
        bne     LE2EC
        bit     PrtData
        bmi     LE2EC
        lda     QuoteSw
        ora     Insrt
        beq     LE2FC
        jsr     CancelIModes
        sta     PrtData
        beq     LE2FC
LE2EC:
        cmp     #$03
        beq     LE2FC
        ldy     Insrt
        bne     LE2F8
        ldy     QuoteSw
        beq     LE2FC
LE2F8:
        ora     #$80
        bne     LE2C3
LE2FC:
        lda     PrtData
        asl     a
        tax
        jsr     LE306
LE303:
        jmp     LE206
; -------------------------------------------------------------------------
LE306:
        lda     WhiteSpaceTab+1,x
        pha
        lda     WhiteSpaceTab,x
        pha
        lda     PrtData
        rts
; -------------------------------------------------------------------------
do_CTRL:
        jmp     (ctrlvec)
; -------------------------------------------------------------------------
; cursor vertical move

CursVertMove:
        bcs     LE323
        jsr     LE37A
LE319:
        jsr     LE4F5
        bcs     LE321
        sec
        ror     LastCol
LE321:
        clc
        rts
; -------------------------------------------------------------------------
LE323:
        ldx     ScreenTop
        cpx     CursLine
        bcs     LE338
LE329:
        jsr     LE319
        dec     CursLine
        jmp     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
; -------------------------------------------------------------------------
; Cursor horizontal move

CursHorMove:
        bcs     LE339
        jsr     LE574
        bcs     LE319
LE338:
        rts
; -------------------------------------------------------------------------
LE339:
        jsr     LE587
        bcs     LE338
        bne     LE321
        inc     CursLine
        bne     LE329

RVSOnOff:
        eor     #$80
        sta     rvsFlag
        rts
; -------------------------------------------------------------------------
; Clear/Home; bei zweifachem Tastendruck CRT-Size rcksetzen

do_ClearHome:
        bcc     LE34F
        jmp     ClrHome
; -------------------------------------------------------------------------
LE34F:
        cmp     LastPrtChar
        bne     LE357
        jsr     ResetCRTSize
LE357:
        jmp     Home
; -------------------------------------------------------------------------
do_tab:
        ldy     CursCol
        bcs     SetResetTab
LE35E:
        cpy     ScreenRight
        bcc     NextTab
        lda     ScreenRight
        sta     CursCol
        rts
; -------------------------------------------------------------------------
NextTab:
        iny
        jsr     ChkTabStop
        beq     LE35E
        sty     CursCol
        rts
; -------------------------------------------------------------------------
SetResetTab:
        jsr     ChkTabStop
        eor     FktTemp
        sta     TabStopTable,x
        rts
; -------------------------------------------------------------------------
LE37A:
        ldx     CursLine
        cpx     ScreenBot
        bcc     LE38F
        bit     ScrollFlag
        bpl     LE38B
        lda     ScreenTop
        sta     CursLine
        bcs     LE391
LE38B:
        jsr     LE3F6
        clc
LE38F:
        inc     CursLine
LE391:
        jmp     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
; -------------------------------------------------------------------------
; CR ausfhren

do_CR:
        jsr     CurToEOL
        inx
        jsr     LE505
        ldy     ScreenLeft
        sty     CursCol
        jsr     LE37A
CancelIModes:
        lda     #$00
        sta     Insrt
        sta     rvsFlag
        sta     QuoteSw
        cmp     BellMode
        bne     LE3B3
        sta     sid+Volume
LE3B3:
        rts
; -------------------------------------------------------------------------
CopyCRTLine:
        lda     LineLSBTab,x
        sta     sedsal
        lda     LineMSBTab,x
        sta     sedsal+1
        jsr     SwitchSeg
LE3C1:
        lda     (sedsal),y
        sta     (CharPtr),y
        cpy     ScreenRight
        iny
        bcc     LE3C1
        jmp     SwitchOldSeg    ; Bank rckschalten
; -------------------------------------------------------------------------
LE3CD:
        ldx     LastCol
        bmi     LE3D7
        cpx     CursLine
        bcc     LE3D7
        inc     LastCol
LE3D7:
        ldx     ScreenBot
LE3D9:
        jsr     LE0CF
        ldy     ScreenLeft
        cpx     CursLine
        beq     LE3F0
        dex
        jsr     LE4F7
        inx
        jsr     LE503
        dex
        jsr     CopyCRTLine
        bcs     LE3D9
LE3F0:
        jsr     EraseLine               ; Zeile lschen
        jmp     LE512
; -------------------------------------------------------------------------
LE3F6:
        ldx     ScreenTop
LE3F8:
        inx
        jsr     LE4F7
        bcc     LE408
        cpx     ScreenBot
        bcc     LE3F8
        ldx     ScreenTop
        inx
        jsr     LE505
LE408:
        dec     CursLine
        bit     LastCol
        bmi     LE410
        dec     LastCol
LE410:
        ldx     ScreenTop
        cpx     sedt2
        bcs     LE418
        dec     sedt2
LE418:
        jsr     LE42D
        ldx     ScreenTop
        jsr     LE4F7
        php
        jsr     LE505
        plp
        bcc     LE42C
        bit     LogScrollFlag
        bmi     LE408
LE42C:
        rts
; -------------------------------------------------------------------------
LE42D:
        jsr     LE0CF
        ldy     ScreenLeft
        cpx     ScreenBot
        bcs     LE444
        inx
        jsr     LE4F7
        dex
        jsr     LE503
        inx
        jsr     CopyCRTLine
        bcs     LE42D
LE444:
        jsr     EraseLine               ; Zeile lschen
        ldx     #$FF
        ldy     #$FE
        jsr     LE480
        and     #$20
        bne     LE45F
LE452:
        nop
        nop
        dex
        bne     LE452
        dey
        bne     LE452
LE45A:
        sty     KeyBufIndex
LE45C:
        jmp     LE8F7
; -------------------------------------------------------------------------
LE45F:
        ldx     #$F7
        ldy     #$FF
        jsr     LE480
        and     #$10
        bne     LE45C
LE46A:
        jsr     LE480
        and     #$10
        beq     LE46A
LE471:
        ldy     #$00
        ldx     #$00
        jsr     LE480
        and     #$3F
        eor     #$3F
        beq     LE471
        bne     LE45A
LE480:
        php
        sei
        stx     tpi2+tpiPortA
        sty     tpi2+tpiPortB
        jsr     LE91E
        plp
        rts
; -------------------------------------------------------------------------
bell:
        lda     BellMode
        bne     LE4B9
        lda     #$0F
        sta     sid+Volume
        ldy     #$00
        sty     sid+Osc1+AtkDcy
        lda     #$0A
        sta     sid+Osc1+SusRel
        lda     #$30
        sta     sid+Osc1+FreqHi
        lda     #$60
        sta     sid+Osc3+FreqHi
        ldx     #$15
        stx     sid+Osc1+OscCtl
LE4B0:
        nop
        nop
        iny
        bne     LE4B0
        dex
        stx     sid+Osc1+OscCtl
LE4B9:
        rts
; -------------------------------------------------------------------------

ClearLastEntry:
        lda     CursCol
        pha
LE4BD:
        ldy     CursCol
        dey
        jsr     LE244
        cmp     #$2B
        beq     LE4CB
        cmp     #$2D
        bne     LE4D3
LE4CB:
        dey
        jsr     LE244
        cmp     #$05
        bne     LE4ED
LE4D3:
        cmp     #$05
        bne     LE4DB
        dey
        jsr     LE244
LE4DB:
        cmp     #$2E
        bcc     LE4ED
        cmp     #$2F
        beq     LE4ED
        cmp     #$3A
        bcs     LE4ED
        jsr     do_DEL
        jmp     LE4BD
; -------------------------------------------------------------------------
LE4ED:
        pla
        cmp     CursCol
        bne     LE4B9
        jmp     do_DEL
; -------------------------------------------------------------------------
LE4F5:
        ldx     CursLine
LE4F7:
        jsr     LE51E
        and     BitTable,x
        cmp     #$01
        jmp     LE50E
; -------------------------------------------------------------------------
LE501:
        ldx     CursLine
LE503:
        bcs     LE512
LE505:
        jsr     LE51E
        eor     #$FF
        and     BitTable,x
LE50C:
        sta     BitTable,x
LE50E:
        ldx     FktTemp
        rts
; -------------------------------------------------------------------------
LE512:
        bit     ScrollFlag
        bvs     LE4F7
        jsr     LE51E
        ora     BitTable,x
        bne     LE50C
LE51E:
        stx     FktTemp
        txa
        and     #$07
        tax
        lda     BitMapTab,x
        pha
        lda     FktTemp
        lsr     a
        lsr     a
        lsr     a
        tax
        pla
        rts
; -------------------------------------------------------------------------
CurToSOL:
        ldy     ScreenLeft
        sty     CursCol
LE536:
        jsr     LE4F5
        bcc     LE541
        dec     CursLine
        bpl     LE536
        inc     CursLine
LE541:
        jmp     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
; -------------------------------------------------------------------------
CurToEOL:
        lda     CursLine
        cmp     ScreenBot
        bcs     LE553
        inc     CursLine
        jsr     LE4F5
        bcs     CurToEOL
        dec     CursLine
LE553:
        jsr     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
GetCRTLineEnd:
        ldy     ScreenRight
        sty     CursCol
        bpl     LE561
LE55C:
        jsr     LE587
        bcs     LE571
LE561:
        jsr     GetChar         ; Zeichen vom Bildschirm holen
        cmp     #$20
        bne     LE571
        cpy     ScreenLeft
        bne     LE55C
        jsr     LE4F5
        bcs     LE55C
LE571:
        sty     LastLinePos
        rts
; -------------------------------------------------------------------------
LE574:
        pha
        ldy     CursCol
        cpy     ScreenRight
        bcc     LE582
        jsr     LE37A
        ldy     ScreenLeft
        dey
        sec
LE582:
        iny
        sty     CursCol
        pla
        rts
; -------------------------------------------------------------------------
LE587:
        ldy     CursCol
        dey
        bmi     LE590
        cpy     ScreenLeft
        bcs     LE59F
LE590:
        ldy     ScreenTop
        cpy     CursLine
        bcs     LE5A4
        dec     CursLine
        pha
        jsr     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
        pla
        ldy     ScreenRight
LE59F:
        sty     CursCol
        cpy     ScreenRight
        clc
LE5A4:
        rts
; -------------------------------------------------------------------------
SaveCursPos:
        ldy     CursCol
        sty     sedt1
        ldx     CursLine
        stx     sedt2
        rts
; -------------------------------------------------------------------------
do_INST_DEL:
        bcs     do_INST
do_DEL:
        jsr     LE339
        jsr     SaveCursPos
        bcs     LE5C7
LE5B8:
        cpy     ScreenRight
        bcc     LE5D2
        ldx     CursLine
        inx
        jsr     LE4F7
        bcs     LE5D2
        jsr     EraseChar
LE5C7:
        lda     sedt1
        sta     CursCol
        lda     sedt2
        sta     CursLine
        jmp     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
; -------------------------------------------------------------------------
LE5D2:
        jsr     LE574
        jsr     GetChar         ; Zeichen vom Bildschirm holen
        jsr     LE587
        jsr     PutChar
        jsr     LE574
        jmp     LE5B8
; -------------------------------------------------------------------------
do_INST:
        jsr     SaveCursPos
        jsr     CurToEOL
        cpx     sedt2
        bne     LE5F0
        cpy     sedt1
LE5F0:
        bcc     LE613
        jsr     LE62E
        bcs     LE619
LE5F7:
        jsr     LE587
        jsr     GetChar         ; Zeichen vom Bildschirm holen
        jsr     LE574
        jsr     PutChar
        jsr     LE587
        ldx     CursLine
        cpx     sedt2
        bne     LE5F7
        cpy     sedt1
        bne     LE5F7
        jsr     EraseChar
LE613:
        inc     Insrt
        bne     LE619
        dec     Insrt
LE619:
        jmp     LE5C7
; -------------------------------------------------------------------------
PrtDLRUN:
        bcc     LE62D
        sei
        ldx     #DLRunTextLen
        stx     KeyBufIndex
LE623:
        lda     DLRunText-1,x
        sta     Keyd-1,x
        dex
        bne     LE623
        cli
LE62D:
        rts
; -------------------------------------------------------------------------
LE62E:
        cpy     ScreenRight
        bcc     LE63D
        ldx     CursLine
        cpx     ScreenBot
        bcc     LE63D
        bit     ScrollFlag
        bmi     LE654
LE63D:
        jsr     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
        jsr     LE574
        bcc     LE654
        jsr     LE4F5
        bcs     LE653
        jsr     LED00
        sec
        bvs     LE654
        jsr     LE3CD
LE653:
        clc
LE654:
        rts
; -------------------------------------------------------------------------
do_ESC:
        jmp     (escvec)
; -------------------------------------------------------------------------
InsLine:
        jsr     LE3CD
        jsr     LE0C7
        inx
        jsr     LE4F7
        php
        jsr     LE501
        plp
        bcs     LE66C
        sec
        ror     LastCol
LE66C:
        rts
; -------------------------------------------------------------------------
DelLine:
        jsr     LE536
        lda     ScreenTop
        pha
        lda     CursLine
        sta     ScreenTop
        lda     LogScrollFlag
        pha
        lda     #$80
        sta     LogScrollFlag
        jsr     LE408
        pla
        sta     LogScrollFlag
        lda     ScreenTop
        sta     CursLine
        pla
        sta     ScreenTop
        sec
        ror     LastCol
        jmp     LE0C7
; -------------------------------------------------------------------------
EraToEOL:
        jsr     SaveCursPos
LE697:
        jsr     LE22C
        inc     CursLine
        jsr     InitLine                ; Zeiger auf Zeilenanfang im RAM setzen
        ldy     ScreenLeft
        jsr     LE4F5
        bcs     LE697
LE6A6:
        jmp     LE5C7
; -------------------------------------------------------------------------
EraToSOL:
        jsr     SaveCursPos
LE6AC:
        jsr     EraseChar
        cpy     ScreenLeft
        bne     LE6B8
        jsr     LE4F5
        bcc     LE6A6
LE6B8:
        jsr     LE587
        bcc     LE6AC
ScrollUp:
        jsr     SaveCursPos
        txa
        pha
        jsr     LE3F6
        pla
        sta     sedt2
        jmp     LE6A6
; -------------------------------------------------------------------------
ScrollDown:
        jsr     SaveCursPos
        jsr     LE4F5
        bcs     LE6D6
        sec
        ror     LastCol
LE6D6:
        lda     ScreenTop
        sta     CursLine
        jsr     LE3CD
        jsr     LE505
        jmp     LE6A6
; -------------------------------------------------------------------------
EnableScroll:
        clc
        .byte   $24
DisableScroll:
        sec
        lda     #$00
        ror     a
        sta     ScrollFlag
        rts
; -------------------------------------------------------------------------
        clc
        bcc     LE6F1
        sec
LE6F1:
        lda     #$00
        ror     a
        sta     LogScrollFlag
        rts
; -------------------------------------------------------------------------
do_funkey:
        sei
        dey
        bmi     LE6FF
        jmp     SetFunKey
; -------------------------------------------------------------------------
LE6FF:
        ldy     #$00
LE701:
        iny
        sty     FunKeyTmp
        dey
        lda     PgmKeySize,y
        beq     LE777
        sta     PgmKeyIndex
        jsr     LE949
        sta     PgmKeyPtr
        stx     PgmKeyPtr+1
        ldx     #$03
LE717:
        lda     ChrTxt,x
        jsr     bsout
        dex
        bpl     LE717
        ldx     #$2F
        lda     FunKeyTmp
        sec
LE726:
        inx
        sbc     #$0A
        bcs     LE726
        adc     #$3A
        cpx     #$30
        beq     LE737
        pha
        txa
        jsr     bsout
        pla
LE737:
        jsr     bsout
        ldy     #$00
        lda     #$2C
LE73E:
        jsr     bsout
        ldx     #$07
LE743:
        jsr     SwToPgmKeySeg   ; Auf Bank mit Funktionstastentexten schalten
        lda     (PgmKeyPtr),y
        jsr     SwitchOldSeg    ; Bank rckschalten
        cmp     #$0D
        beq     LE781
        cmp     #$8D
        beq     LE784
        cmp     #$22
        beq     LE787
        cpx     #$09
        beq     LE762
        pha
        lda     #$22
        jsr     bsout
        pla
LE762:
        jsr     bsout
        ldx     #$09
        iny
        cpy     PgmKeyIndex
        bne     LE743
        lda     #$22
        jsr     bsout
LE772:
        lda     #$0D
        jsr     bsout
LE777:
        ldy     FunKeyTmp
        cpy     #$14
        bne     LE701
        cli
        clc
        rts
; -------------------------------------------------------------------------
LE781:
        ldx     #ChrStr13Txt-1
        .byte   $2C
LE784:
        ldx     #ChrStr141Txt-1
        .byte   $2C
LE787:
        ldx     #ChrStr34Txt-1
        txa
        pha
        ldx     #ChrStrTxt-1
LE78D:
        lda     ChrTxt1,x
        beq     LE79C
        jsr     bsout
        dex
        bpl     LE78D
        pla
        tax
        bne     LE78D
LE79C:
        iny
        cpy     PgmKeyIndex
        beq     LE772
        lda     #$2B
        bne     LE73E


ChrTxt:
        .byte   " YEK"
ChrTxt1:
        .byte   "($RHC+",'"'
ChrStrTxt       = (*-ChrTxt1)
        .byte   $00
        .byte   ")31"
ChrStr13Txt     = (*-ChrTxt1)
        .byte   $00
        .byte   ")43"
ChrStr34Txt     = (*-ChrTxt1)
        .byte   $00
        .byte   ")141"
ChrStr141Txt    = (*-ChrTxt1)

; -------------------------------------------------------------------------
SetFunKey:
        pha
        tax
        sty     sedt1
        lda     ExecReg,x
        sec
        sbc     PgmKeySize,y
        sta     sedt2
        ror     FktTemp
        iny
        jsr     LE949
        sta     sedsal
        stx     sedsal+1
        ldy     #$14
        jsr     LE949
        sta     sedeal
        stx     sedeal+1
        ldy     FktTemp
        bpl     LE7F6
        clc
        sbc     PgmKeyEnd
        tay
        txa
        sbc     PgmKeyEnd+1
        tax
        tya
        clc
        adc     sedt2
        txa
        adc     #$00
        bcs     LE862
LE7F6:
        jsr     SwToPgmKeySeg   ; Auf Bank mit Funktionstastentexten schalten
LE7F9:
        lda     sedeal
        clc
        sbc     sedsal
        lda     sedeal+1
        sbc     sedsal+1
        bcc     LE82E
        ldy     #$00
        lda     FktTemp
        bpl     LE81C
        lda     sedeal
        bne     LE811
        dec     sedeal+1
LE811:
        dec     sedeal
        lda     (sedeal),y
        ldy     sedt2
        sta     (sedeal),y
        jmp     LE7F9
; -------------------------------------------------------------------------
LE81C:
        lda     (sedsal),y
        ldy     sedt2
        dec     sedsal+1
        sta     (sedsal),y
        inc     sedsal+1
        inc     sedsal
        bne     LE7F9
        inc     sedsal+1
        bne     LE7F9
LE82E:
        ldy     sedt1
        jsr     LE949
        sta     sedsal
        stx     sedsal+1
        ldy     sedt1
        pla
        pha
        tax
        lda     ExecReg,x
        sta     PgmKeySize,y
        tay
        beq     LE85E
        lda     IndReg,x
        sta     sedeal
        lda     $02,x
        sta     sedeal+1
LE84C:
        dey
        lda     $03,x
        sta     IndReg
        lda     (sedeal),y
        jsr     SwitchOldSeg    ; Bank rckschalten
        jsr     SwToPgmKeySeg   ; Auf Bank mit Funktionstastentexten schalten
        sta     (sedsal),y
        tya
        bne     LE84C
LE85E:
        jsr     SwitchOldSeg    ; Bank rckschalten
        clc
LE862:
        pla
        cli
        rts
; -------------------------------------------------------------------------
do_scnkey:
        ldy     #$FF
        sty     ModKey
        sty     NorKey
        iny
        sty     tpi2+tpiPortB
        sty     tpi2+tpiPortA
        jsr     LE91E
        and     #$3F
        eor     #$3F
        bne     LE87E
        jmp     LE8F3
; -------------------------------------------------------------------------
LE87E:
        lda     #$FF
        sta     tpi2+tpiPortA
        asl     a
        sta     tpi2+tpiPortB
        jsr     LE91E
        pha
        sta     ModKey
        ora     #$30
        bne     LE894
LE891:
        jsr     LE91E
LE894:
        ldx     #$05
LE896:
        lsr     a
        bcc     LE8A9
        iny
        dex
        bpl     LE896
        sec
        rol     tpi2+tpiPortB
        rol     tpi2+tpiPortA
        bcs     LE891
        pla
        bcc     LE8F3
LE8A9:
        sty     NorKey
        ldx     TastTab,y
        pla
        asl     a
        asl     a
        asl     a
        bcc     LE8C2
        bmi     LE8C5
        ldx     TastTabShiftNorm,y
        lda     GrafMode
        beq     LE8C5
        ldx     TastTabShiftGraph,y
        bne     LE8C5
LE8C2:
        ldx     TastTabCtrl,y
LE8C5:
        cpx     #$FF
        beq     LE8F5
        cpx     #$E0
        bcc     LE8D6
        tya
        pha
        jsr     LE927
        pla
        tay
        bcs     LE8F5
LE8D6:
        txa
        cpy     LastIndex
        beq     RepeatKey
        ldx     #$13
        stx     RepeatDelay
        ldx     KeyBufIndex
        cpx     #$09
        beq     LE8F3
        cpy     #$59
        bne     LE912
        cpx     #$08
        beq     LE8F3
        sta     Keyd,x
        inx
        bne     LE912
LE8F3:
        ldy     #$FF
LE8F5:
        sty     LastIndex
LE8F7:
        ldx     #$7F
        stx     tpi2+tpiPortA
        ldx     #$FF
        stx     tpi2+tpiPortB
        rts
; -------------------------------------------------------------------------
RepeatKey:
        dec     RepeatDelay
        bpl     LE8F7
        inc     RepeatDelay
        dec     RepeatCount
        bpl     LE8F7
        inc     RepeatCount
        ldx     KeyBufIndex
        bne     LE8F7
LE912:
        sta     Keyd,x
        inx
        stx     KeyBufIndex
        ldx     #$03
        stx     RepeatCount
        bne     LE8F5
LE91E:
        lda     tpi2+tpiPortC
        cmp     tpi2+tpiPortC
        bne     LE91E
        rts
; -------------------------------------------------------------------------
LE927:
        jmp     (funvec)                ; normalerweise ProcessFunKey
; -------------------------------------------------------------------------
; Funktionstasten behandeln

ProcessFunKey:
        cpy     LastIndex
        beq     LE947
        lda     KeyBufIndex
        ora     KeyIndex
        bne     LE947
        sta     PgmKeyIndex
        txa
        and     #$1F
        tay
        lda     PgmKeySize,y
        sta     KeyIndex
        jsr     LE949
        sta     PgmKeyPtr
        stx     PgmKeyPtr+1
LE947:
        sec
        rts
; -------------------------------------------------------------------------
LE949:
        lda     PgmKeyBuf
        ldx     PgmKeyBuf+1
LE94D:
        clc
        dey
        bmi     LE959
        adc     PgmKeySize,y
        bcc     LE94D
        inx
        bne     LE94D
LE959:
        rts
; -------------------------------------------------------------------------
ChkTabStop:
        tya
        and     #$07
        tax
        lda     BitMapTab,x
        sta     FktTemp
        tya
        lsr     a
        lsr     a
        lsr     a
        tax
        lda     TabStopTable,x
        bit     FktTemp
        rts
; -------------------------------------------------------------------------
ESCseq:
        and     #$7F
        sec
        sbc     #$41
        cmp     #$1A
        bcc     jmpESCseq
CancelESC:
        rts
; -------------------------------------------------------------------------
jmpESCseq:
        asl     a
        tax
        lda     ESCjmpTab+1,x
        pha
        lda     ESCjmpTab,x
        pha
        rts
; -------------------------------------------------------------------------
ESCjmpTab:
        .word   InsertOn-1              ; A
        .word   SetWinRUCur-1           ; B
        .word   InsertOff-1             ; C
        .word   DelLine-1               ; D
        .word   NonFlashCurs-1          ; E
        .word   FlashingCurs-1          ; F
        .word   BellOn-1                ; G
        .word   BellOff-1               ; H
        .word   InsLine-1               ; I
        .word   CurToSOL-1              ; J
        .word   CurToEOL-1              ; K
        .word   EnableScroll-1          ; L
        .word   DisableScroll-1         ; M
        .word   NormScreen-1            ; N
        .word   CancelIModes-1          ; O
        .word   EraToSOL-1              ; P
        .word   EraToEOL-1              ; Q
        .word   RVSScreen-1             ; R
        .word   SolidCurs-1             ; S
        .word   SetWinRU-1              ; T
        .word   UnderscCurs-1           ; U
        .word   ScrollUp-1              ; V
        .word   ScrollDown-1            ; W
        .word   CancelESC-1             ; X
        .word   NormCharSet-1           ; Y
        .word   AltCharSet-1            ; Z

; -------------------------------------------------------------------------
SetWinRU:
        clc
        .byte   $24
SetWinRUCur:
        sec
do_WinRuCur:                    ; Einsprung von CTRL mit vorbesetztem Carry
        ldx     CursCol
        lda     CursLine
        bcc     SetWinLO
LE9C2:
        sta     ScreenBot
        stx     ScreenRight
        rts
; -------------------------------------------------------------------------
ResetCRTSize:
        lda     #$18
        ldx     #$4F
        jsr     LE9C2
        lda     #$00
        tax
SetWinLO:
        sta     ScreenTop
        stx     ScreenLeft
        rts
; -------------------------------------------------------------------------
BellOn:
        lda     #$00
BellOff:
        sta     BellMode
        rts
; -------------------------------------------------------------------------
UnderscCurs:
        lda     #$0B
        bit     tpi2+tpiPortC
        bmi     LE9E8
        lda     #$06
        .byte   $2c
FlashingCurs:
        lda     #$60
LE9E8:
        ora     Config
        bne     LE9F3
SolidCurs:
        lda     #$F0
        .byte   $2C
NonFlashCurs:
        lda     #$0F
        and     Config
LE9F3:
        sta     Config
        rts
; -------------------------------------------------------------------------
RVSScreen:
        lda     #$20
        .byte   $2C
AltCharSet:
        lda     #$10
        ldx     #$0E
        stx     crtc+CAdrReg
        ora     crtc+CDataReg
        bne     LEA12
NormScreen:
        lda     #$DF
        .byte   $2C
NormCharSet:
        lda     #$EF
        ldx     #$0E
        stx     crtc+CAdrReg
        and     crtc+CDataReg
LEA12:
        sta     crtc+CDataReg
        and     #$30
        ldx     #$0C
        stx     crtc+CAdrReg
        sta     crtc+CDataReg
        rts
; -------------------------------------------------------------------------
InsertOff:
        lda     #$00
        .byte   $2C
InsertOn:
        lda     #$FF
        sta     InsertFlag
        rts
; -------------------------------------------------------------------------
TastTab:
        .byte   $E0,$1B,$09,$FF,$00,$01,$E1,$31
        .byte   $51,$41,$5A,$FF,$E2,$32,$57,$53
        .byte   $58,$43,$E3,$33,$45,$44,$46,$56
        .byte   $E4,$34,$52,$54,$47,$42,$E5,$35
        .byte   $36,$59,$48,$4E,$E6,$37,$55,$4A
        .byte   $4D,$20,$E7,$38,$49,$4B,$2C,$2E
        .byte   $E8,$39,$4F,$4C,$3B,$2F,$E9,$30
        .byte   $2D,$50,$5B,$27,$11,$3D,$5F,$5D
        .byte   $0D,$DE,$91,$9D,$1D,$14,$02,$FF
        .byte   $13,$3F,$37,$34,$31,$30,$12,$04
        .byte   $38,$35,$32,$2E,$8E,$2A,$39,$36
        .byte   $33,$30,$03,$2F,$2D,$2B,$0D,$FF
; -------------------------------------------------------------------------
TastTabShiftNorm:
        .byte   $EA,$1B,$89,$FF,$00,$01,$EB,$21
        .byte   $D1,$C1,$DA,$FF,$EC,$40,$D7,$D3
        .byte   $D8,$C3,$ED,$23,$C5,$C4,$C6,$D6
        .byte   $EE,$24,$D2,$D4,$C7,$C2,$EF,$25
        .byte   $5E,$D9,$C8,$CE,$F0,$26,$D5,$CA
        .byte   $CD,$A0,$F1,$2A,$C9,$CB,$3C,$3E
        .byte   $F2,$28,$CF,$CC,$3A,$3F,$F3,$29
        .byte   $2D,$D0,$5B,$22,$11,$2B,$5C,$5D
        .byte   $8D,$DE,$91,$9D,$1D,$94,$82,$FF
        .byte   $93,$3F,$37,$34,$31,$30,$92,$84
        .byte   $38,$35,$32,$2E,$0E,$2A,$39,$36
        .byte   $33,$30,$83,$2F,$2D,$2B,$8D,$FF
; -------------------------------------------------------------------------
TastTabShiftGraph:
        .byte   $EA,$1B,$89,$FF,$00,$01,$EB,$21
        .byte   $D1,$C1,$DA,$FF,$EC,$40,$D7,$D3
        .byte   $D8,$C0,$ED,$23,$C5,$C4,$C6,$C3
        .byte   $EE,$24,$D2,$D4,$C7,$C2,$EF,$25
        .byte   $5E,$D9,$C8,$DD,$F0,$26,$D5,$CA
        .byte   $CD,$A0,$F1,$2A,$C9,$CB,$3C,$3E
        .byte   $F2,$28,$CF,$D6,$3A,$3F,$F3,$29
        .byte   $2D,$D0,$5B,$22,$11,$2B,$5C,$5D
        .byte   $8D,$DE,$91,$9D,$1A,$94,$82,$FF
        .byte   $93,$3F,$37,$34,$31,$30,$92,$04
        .byte   $38,$35,$32,$2E,$0E,$2A,$39,$36
        .byte   $33,$30,$83,$2F,$2D,$2B,$8D,$FF
; -------------------------------------------------------------------------
TastTabCtrl:
        .byte   $FF,$FF,$FF,$FF,$FF,$FF,$FF,$A1
        .byte   $11,$01,$1A,$FF,$FF,$A2,$17,$13
        .byte   $18,$03,$FF,$A3,$05,$04,$06,$16
        .byte   $FF,$A4,$12,$14,$07,$02,$FF,$A5
        .byte   $A7,$19,$08,$0E,$FF,$BE,$15,$0A
        .byte   $0D,$FF,$FF,$BB,$09,$0B,$CE,$FF
        .byte   $FF,$BF,$0F,$0C,$DC,$FF,$FF,$AC
        .byte   $BC,$10,$CC,$A8,$FF,$A9,$DF,$BA
        .byte   $FF,$A6,$FF,$FF,$FF,$FF,$FF,$FF
        .byte   $FF,$B7,$B4,$B1,$B0,$AD,$FF,$B8
        .byte   $B5,$B2,$AE,$BD,$FF,$B9,$B6,$B3
        .byte   $DB,$FF,$FF,$AF,$AA,$AB,$FF,$FF
; -------------------------------------------------------------------------
DLRunText:
        .byte   'D','L'+$80,'"','*',$0d
        .byte   "RUN"
        .byte   $0d

        DLRunTextLen    = (*-DLRunText)

; -------------------------------------------------------------------------
LineLSBTab:
        .byte   $00,$50,$A0,$F0,$40,$90,$E0,$30
        .byte   $80,$D0,$20,$70,$C0,$10,$60,$B0
        .byte   $00,$50,$A0,$F0,$40,$90,$E0,$30
        .byte   $80
; -------------------------------------------------------------------------
LineMSBTab:
        .byte   $D0,$D0,$D0,$D0,$D1,$D1,$D1,$D2
        .byte   $D2,$D2,$D3,$D3,$D3,$D4,$D4,$D4
        .byte   $D5,$D5,$D5,$D5,$D6,$D6,$D6,$D7
        .byte   $D7
; -------------------------------------------------------------------------
WhiteSpaceTab:
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   PrtDLRUN-1
        .word   ClearLastEntry-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   Bell-1
        .word   do_CTRL-1
        .word   do_tab-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CR-1
        .word   SwitchCase-1
        .word   do_WinRUCur-1
        .word   do_CTRL-1
        .word   CursVertMove-1
        .word   RVSOnOff-1
        .word   do_ClearHome-1
        .word   do_INST_DEL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   do_CTRL-1
        .word   CursHorMove-1
        .word   do_CTRL-1
        .word   do_CTRL-1
; -------------------------------------------------------------------------
; Lnge der Texte fr die Vorbelegung der Funktionstasten 1-10

PgmKeyDefLen:
        .byte   5,4,6,6,5,6,4,9,7,5

        DefPgmKeyAnz    = (*-PgmKeyDefLen)

; -------------------------------------------------------------------------
; Texte fr die Vorbelegung der Funktionstasten 1-10

PgmKeyDefTxt:
        .byte   "PRINT"
        .byte   "LIST"
        .byte   "DLOAD",'"'
        .byte   "DSAVE",'"'
        .byte   "DOPEN"
        .byte   "DCLOSE"
        .byte   "COPY"
        .byte   "DIRECTORY"
        .byte   "SCRATCH"
        .byte   "CHR$("

        PgmKeyTxtLen    = (*-PgmKeyDefTxt)

; -------------------------------------------------------------------------
BitMapTab:
        .byte   $80,$40,$20,$10,$08,$04,$02,$01
; -------------------------------------------------------------------------
; Konstanten zur Initialisierung des Video-Controllers

m6545tab:
        .byte   $6C,$50,$53,$0F,$19,$03,$19,$19
        .byte   $00,$0D,$60,$0D,$00,$00,$00,$00
        .byte   $00,$00,$7E,$50,$62,$0A,$1F,$06
        .byte   $19,$1C,$00,$07,$00,$07,$00,$00
        .byte   $00,$00,$00,$00,$7F,$50,$60,$0A
        .byte   $26,$01,$19,$1E,$00,$07,$00,$07
        .byte   $00,$00,$00,$00,$00,$00,$65
; -------------------------------------------------------------------------
        .res    90,$aa
; -------------------------------------------------------------------------
LED00:
        ldx     ScreenBot
        cpx     ScreenTop
        bne     LED08
        pla
        pla
LED08:
        bit     ScrollFlag
        rts
; -------------------------------------------------------------------------
        .res    244,$aa
; -------------------------------------------------------------------------


